/* ===================================================================== *
 *                                                                       *
 * Menu Callback Function                                                *
 *                                                                       *
 * ===================================================================== *
 *
 * EXAMPLE CODE:

// *********************************************************************
void your_function_name(uint8_t param)
// *********************************************************************
{
  if(LCDML.FUNC_setup())          // ****** SETUP *********
  {
    // setup
    // is called only if it is started

    // starts a trigger event for the loop function every 100 milliseconds
    LCDML.FUNC_setLoopInterval(100);
  }

  if(LCDML.FUNC_loop())           // ****** LOOP *********
  {
    // loop
    // is called when it is triggered
    // - with LCDML_DISP_triggerMenu( milliseconds )
    // - with every button status change

    // check if any button is pressed (enter, up, down, left, right)
    if(LCDML.BT_checkAny()) {
      LCDML.FUNC_goBackToMenu();
    }
  }

  if(LCDML.FUNC_close())      // ****** STABLE END *********
  {
    // loop end
    // you can here reset some global vars or delete it
  }
}


 * ===================================================================== *
 */


// *********************************************************************
void mFunc_information(uint8_t param)
// *********************************************************************
{
  if(LCDML.FUNC_setup())          // ****** SETUP *********
  {
    // setup function
    lcd.setCursor(0, 0);
    lcd.print("versi1.1");
  }

  if(LCDML.FUNC_loop())           // ****** LOOP *********
  {
    // loop function, can be run in a loop when LCDML_DISP_triggerMenu(xx) is set
    // the quit button works in every DISP function without any checks; it starts the loop_end function
    if(LCDML.BT_checkAny()) { // check if any button is pressed (enter, up, down, left, right)
      // LCDML_goToMenu stops a running menu function and goes to the menu
      LCDML.FUNC_goBackToMenu();
    }
  }

  if(LCDML.FUNC_close())      // ****** STABLE END *********
  {
    // you can here reset some global vars or do nothing
  }
}


// *********************************************************************
uint8_t g_func_timer_info = 0;  // time counter (global variable)
unsigned long g_timer_1 = 0;    // timer variable (global variable)
void mFunc_timer_info(uint8_t param)
// *********************************************************************
{
  if(LCDML.FUNC_setup())          // ****** SETUP *********
  {
    /*lcd.print(F("20 sec wait")); // print some content on first row
    g_func_timer_info = 20;       // reset and set timer
    LCDML.FUNC_setLoopInterval(100);  // starts a trigger event for the loop function every 100 milliseconds

    LCDML.TIMER_msReset(g_timer_1);*/
      DateTime now = rtc.now();
      lcd.setCursor(0, 0); // set cursor
      lcd.print(daysOfTheWeek[now.dayOfTheWeek()]);
      lcd.print(" ");
      lcd.print(now.day());
      lcd.print("/");
      lcd.print(now.month(),DEC);
      lcd.print("/");
      lcd.print(now.year(),DEC);
      lcd.setCursor(4,1);
      lcd.print(now.hour(),DEC);
      lcd.print(":");
      lcd.print(now.minute(),DEC);
      lcd.print(":");
      lcd.print(now.second(),DEC);
      delay(100);
  }


  if(LCDML.FUNC_loop())           // ****** LOOP *********
  {
    /*// loop function, can be run in a loop when LCDML_DISP_triggerMenu(xx) is set
    // the quit button works in every DISP function without any checks; it starts the loop_end function

    // reset screensaver timer
    LCDML.SCREEN_resetTimer();

    // this function is called every 100 milliseconds

    // this method checks every 1000 milliseconds if it is called
    if(LCDML.TIMER_ms(g_timer_1, 1000)) {
      g_func_timer_info--;                // increment the value every second
      lcd.setCursor(0, 0);                // set cursor pos
      lcd.print(F("  "));
      lcd.setCursor(0, 0);                // set cursor pos
      lcd.print(g_func_timer_info);       // print the time counter value*/
      lcd.clear();
      int credit,Num;
      menu = 0;
      char key = kpd.getKey();
      if (key == '#')
      {
        menu=menu+1;
        if(menu==2){p=1;}
        if(menu==1){p=0;}
      }
      if (menu==0)
      {
        DisplaySetHour();
      }
      if (menu==1)
      {
        DisplaySetMinute();  // set minute
      }
      if (menu==2)
      {
      DisplaySetDay();      // set day
      }
      if (menu==3)
      {
        DisplaySetMonth();   // set Month
      }
      if (menu==4)
      { 
        DisplaySetYear();    // set year   
      }
      if (menu==5)
      {
        StoreAgg();
        delay(500);
        LCDML.FUNC_goBackToMenu();
      }
    }

    // this function can only be ended when quit button is pressed or the time is over
    // check if the function ends normally
   /* if (g_func_timer_info <= 0)
    {
      // leave this function
      LCDML.FUNC_goBackToMenu();
    }*/

  if(LCDML.FUNC_close())      // ****** STABLE END *********
  {
    //lcd.print("Setting OK");
    // you can here reset some global vars or do nothing
  }
}


// *********************************************************************
uint8_t g_button_value = 0; // button value counter (global variable)
void mFunc_p2(uint8_t param)
// *********************************************************************
{
  if(LCDML.FUNC_setup())          // ****** SETUP *********
  {
    // setup function
    // print LCD content
    // print LCD content
    lcd.setCursor(0, 0);
    lcd.print(F("press left or up"));
    lcd.setCursor(0, 1);
    lcd.print(F("count: 0 of 3"));
    // Reset Button Value
    g_button_value = 0;

    // Disable the screensaver for this function until it is closed
    LCDML.FUNC_disableScreensaver();

  }

  if(LCDML.FUNC_loop())           // ****** LOOP *********
  {
    // the quit button works in every DISP function without any checks; it starts the loop_end function
    if (LCDML.BT_checkAny()) // check if any button is pressed (enter, up, down, left, right)
    {
      if (LCDML.BT_checkLeft() || LCDML.BT_checkUp()) // check if button left is pressed
      {
        LCDML.BT_resetLeft(); // reset the left button
        LCDML.BT_resetUp(); // reset the left button
        g_button_value++;

        // update LCD content
        // update LCD content
        lcd.setCursor(7, 1); // set cursor
        lcd.print(g_button_value); // print change content
      }
    }

    // check if button count is three
    if (g_button_value >= 3) {
      LCDML.FUNC_goBackToMenu();      // leave this function
    }
  }

  if(LCDML.FUNC_close())     // ****** STABLE END *********
  {
    // you can here reset some global vars or do nothing
  }
}



// *********************************************************************
void mFunc_screensaver(uint8_t param)
// *********************************************************************
{
  //rtc.begin();
  if(LCDML.FUNC_setup())          // ****** SETUP *********
  {
    LCDML.FUNC_setLoopInterval(100);  // starts a trigger event for the loop function every 100 milliseconds
    lcd.clear();
  }

  if(LCDML.FUNC_loop())
  {
    //rtc.adjust(DateTime(2018, 12, 31, 00, 41, 20));
    DateTime now = rtc.now();
    lcd.setCursor(0, 0); // set cursor
    lcd.print(daysOfTheWeek[now.dayOfTheWeek()]);
    lcd.print(" ");
    lcd.print(now.day());
    lcd.print("/");
    lcd.print(now.month(),DEC);
    lcd.print("/");
    lcd.print(now.year(),DEC);
    lcd.setCursor(4,1);
    if (now.hour ()< 10)
    {
      lcd.print("0");
    }
    lcd.print(now.hour(),DEC);
    lcd.print(":");
    if (now.minute ()< 10)
    {
      lcd.print("0");
    }
    lcd.print(now.minute(),DEC);
    lcd.print(":");
    if (now.second ()< 10)
    {
      lcd.print("0");
    }
    lcd.print(now.second(),DEC);
    //delay(1000);
    if (LCDML.BT_checkAny()) // check if any button is pressed (enter, up, down, left, right)
    {
      LCDML.FUNC_goBackToMenu();  // leave this function
    }
  }

  if(LCDML.FUNC_close())
  {
    // The screensaver go to the root menu
    LCDML.MENU_goRoot();
  }
}



// *********************************************************************
void mFunc_back(uint8_t param)
// *********************************************************************
{
  if(LCDML.FUNC_setup())          // ****** SETUP *********
  {
    // end function and go an layer back
    LCDML.FUNC_goBackToMenu(1);      // leave this function and go a layer back
  }
}


// *********************************************************************
void mFunc_goToRootMenu(uint8_t param)
// *********************************************************************
{
  if(LCDML.FUNC_setup())          // ****** SETUP *********
  {
    // go to root and display menu
    LCDML.MENU_goRoot();
  }
}

// *********************************************************************
void mFunc_jumpTo_timer_info(uint8_t param)
// *********************************************************************
{
  if(LCDML.FUNC_setup())          // ****** SETUP *********
  {
    // Jump to main screen
    if(!LCDML.OTHER_jumpToFunc(mFunc_timer_info))
    {
      // function not found or not callable
      LCDML.MENU_goRoot();
    }
  }
}

void DisplaySetHour()
{
  int  Credit,Num;
// time setting
  p = 0;
  lcd_show(0,0,"Set Hour:",0,1);  
  hourupg = GetNum(2,12,2);   
  if(hourupg < 0 or hourupg > 23){menu = 0;}
  //Serial.println(hourupg);
  delay(100);
}
void DisplaySetMinute()
{
// Setting the minutes
  p = 0;
  lcd_show(0,0,"Set Minute:",0,1);
  minupg = GetNum(2,12,2);
  if(minupg < 0 or minupg > 59) {menu = 1;}
  //Serial.println(minupg);
  delay(100);
}
  
void DisplaySetYear()
{
  // setting the year
  p = 0;
  lcd_show(0,0,"Set Year:",0,1);
  yearupg = GetNum(4,12,2);
  if(yearupg < 0 or yearupg > 99){menu = 4;}
  Serial.println(yearupg);
  delay(100);
}

void DisplaySetMonth()
{
  // Setting the month
  p = 0;
  lcd_show(0,0,"Set Month:",0,1);
  monthupg = GetNum(2,12,2);
  if(monthupg < 0 or monthupg > 12) {menu = 3 ;}
  //Serial.println(monthupg);
  delay(100);
}

void DisplaySetDay()
{
  // Setting the day
  p = 0;
  lcd_show(0,0,"Set Day:",0,1);
  dayupg = GetNum(2,12,2);
  if(dayupg < 0 or dayupg > 31) {
    menu = 2 ; 
  };
  //Serial.println(dayupg);
  delay(100);
}

void StoreAgg()
{

  // Variable saving
  lcd.clear();
  lcd.setCursor(0,0);
  lcd.print("SAVING IN");
  lcd.setCursor(8,1);
  lcd.print("PROGRESS");
  seconds = 0 ; 
  day     = 0 ;
  Wire.beginTransmission(DS3231_ADDR);
  Wire.write(0x00);
  Wire.write(decToBcd(seconds));
  Wire.write(decToBcd(minupg));
  Wire.write(decToBcd(hourupg));
  Wire.write(decToBcd(day));
  Wire.write(decToBcd(dayupg));
  Wire.write(decToBcd(monthupg));
  Wire.write(decToBcd(yearupg));
  Wire.endTransmission();
  delay(1000);
  lcd.clear();
  delay(200);
}
byte decToBcd(byte val)
{
  return ( (val/10*16) + (val%10) );
}


/*  Google +     https://goo.gl/yQfMTi      ****/
/*  facebook    https://goo.gl/3rFLMG      ****/
/*  bloger  http://surinidea.blogspot.com/  ****/
/*  Email   fluke49@gmail.com  */
/*-------------------------------------------------------------*
*  Slide Number                                                *
*-------------------------------------------------------------*/
void NumToChar(unsigned long Num, char  *Buffer,unsigned char Digit)
{char i;
   for(i=(Digit-1);i>= 0;i--)
    { Buffer[i] =  (Num % 10) + '0';
      Num = Num / 10;
    }  
   for(i=0;i<Digit;i++)
    { if(Buffer[i] == '0'){Buffer[i] =  ' ';}else{i =100;}
                         
    }   
}

/*  Google +     https://goo.gl/yQfMTi      ****/
/*  facebook    https://goo.gl/3rFLMG      ****/
/*  bloger  http://surinidea.blogspot.com/  ****/
/*  Email   fluke49@gmail.com  */
/*-------------------------------------------------------------*
*  Slide Number                                                *
*-------------------------------------------------------------*/
char BufNum[8];
void  SlideNum(void)
{
  BufNum[6]  = BufNum[5];
  BufNum[5]  = BufNum[4];
  BufNum[4]  = BufNum[3];
  BufNum[3]  = BufNum[2];
  BufNum[2]  = BufNum[1];
  BufNum[1]  = BufNum[0];
}
/*  Google +     https://goo.gl/yQfMTi      ****/
/*  facebook    https://goo.gl/3rFLMG      ****/
/*  bloger  http://surinidea.blogspot.com/  ****/
/*  Email   fluke49@gmail.com  */
/*-------------------------------------------------------------*
* Get Number From Keypad                                      *
*-------------------------------------------------------------*/
unsigned long GetNum(int Count,int X,int Y)
{ char Key,i,N;
  int Sum; 
  lcd.blink();
  lcd.setCursor(X+(Count-2),Y-1); 
  N = 0;
  for(i=0;i<Count;i++){BufNum[i] = ' ';}
  i = 0;
  Key =  kpd.getKey();
  while(p != 1)
  { 
         
    Key = NO_KEY;
    while(Key == NO_KEY){Key =  kpd.getKey();}
    //Beep(); delay(300);
   if(Key == '#'){menu = menu+1; p = 1; }             
   if((N < Count)&&(Key >= '0')&&(Key <= '9'))
   { SlideNum();
     BufNum[0] = Key;
     N++;
   }
   lcd.setCursor(X-1,Y-1);
   for(i=0;i<Count;i++){lcd.print(BufNum[Count-(i+1)]);}
   lcd.setCursor(X+(Count-2),Y-1);  
  }
Sum = 0;
if (Count != 4)
{
for(i=0;i<Count;i++)
 {
   if(BufNum[Count-(i+1)]==0x20){BufNum[Count-(i+1)] = '0';}
   Sum = (Sum*10) + (BufNum[Count-(i+1)]-'0');
 }
}
 if (Count == 4)
 {
  Count = 2;
 
 for(i=0;i<Count;i++)
 {
   if(BufNum[Count-(i+1)]==0x20){BufNum[Count-(i+1)] = '0';}
   Sum = (Sum*10) + (BufNum[Count-(i+1)]-'0');
 }
 }
 //Serial.println(hours);
lcd.noCursor();
lcd.noBlink();

return(Sum);  
}
/*  Google +     https://goo.gl/yQfMTi      ****/
/*  facebook    https://goo.gl/3rFLMG      ****/
/*  bloger  http://surinidea.blogspot.com/  ****/
/*  Email   fluke49@gmail.com  */
/*-------------------------------------------------------------*
*  Beep  Sound  active Low                                               *
*-------------------------------------------------------------*/
/*  Google +     https://goo.gl/yQfMTi      ****/
/*  facebook    https://goo.gl/3rFLMG      ****/
/*  bloger  http://surinidea.blogspot.com/  ****/
/*  Email   fluke49@gmail.com  */
//*************************************************************
//LCD Display

void lcd_show(int b,int c,char* txt0,int d,int e)
{
  lcd.clear();
  lcd.setCursor(b,c);
  lcd.print(txt0);
  lcd.setCursor(d,e);
}
/*  Google +     https://goo.gl/yQfMTi      ****/
/*  facebook    https://goo.gl/3rFLMG      ****/
/*  bloger  http://surinidea.blogspot.com/  ****/
/*  Email   fluke49@gmail.com  */

// =====================================================================
void mFunc_para(uint8_t param)
// *********************************************************************
{
  if(LCDML.FUNC_setup())          // ****** SETUP *********
  {

    //char buf[20];
    //sprintf (buf, "Mode : %d", param);

    LCDML.FUNC_setLoopInterval(100);  // starts a trigger event for the loop function every 100 milliseconds
  }

  if(LCDML.FUNC_loop())          // ****** LOOP *********
  {
    // For example
    switch(param)
    {
      case 1:
        // do something
          lcd.setCursor(0,0);
          lcd.print(F("Berhasil"));
          lcd.setCursor(0,1);
          lcd.print(F("Diaktifkan"));
          digitalWrite(ledPin,HIGH);
          delay(1000);
          //diaktifkan();
          LCDML.FUNC_goBackToMenu();
        break;

      case 2:
        // do something
          lcd.setCursor(0,0);
          lcd.print(F("Berhasil"));
          lcd.setCursor(0,1);
          lcd.print(F("Dinoaktifkan"));
          delay(1000);
          //digitalWrite(relay1,HIGH);
          //digitalWrite(relay2,HIGH);
          digitalWrite(ledPin,LOW);
          LCDML.FUNC_goBackToMenu();
        break;

      default:
        // do nothing
        break;
    }


    if (LCDML.BT_checkAny()) // check if any button is pressed (enter, up, down, left, right)
    {
      LCDML.FUNC_goBackToMenu();  // leave this function
    }
  }

  if(LCDML.FUNC_close())        // ****** STABLE END *********
  {
    // you can here reset some global vars or do nothing
  }
}


void diaktifkan()
{
   if (OperationA < millis())
      {
      digitalWrite(relay2,HIGH);
      digitalWrite(relay1,LOW);
      OperationA = millis() + 500;
      }
      if (OperationB < millis())
      {
      digitalWrite(relay2,LOW);
      digitalWrite(relay1,HIGH);
      OperationB = millis() + 1000;
      }
      delay(100);
}

